unit MasterVol;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,MMSystem;

type
  TmMasterVol = class(tcomponent)
  private
    FMixer: HmixerObj;
    function GetMasterVolume: Word;
    procedure SetMasterVolume(const Value: Word);
    function GetMasterVolumeControl(Mixer: hMixerObj;
      var Control: TMixerControl): MMResult;
    procedure SetMixer(const Value: HmixerObj);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
     Property MasterVolume:Word read GetMasterVolume write SetMasterVolume stored false;
     Property Mixer:HmixerObj read FMixer write SetMixer;
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Mcaselli', [TmMasterVol]);
end;

{ TmMasterVol }

function TmMasterVol.GetMasterVolume: Word;
var
  MasterVolume: TMixerControl;
  Details: TMixerControlDetails;
  UnsignedDetails: TMixerControlDetailsUnsigned;
  Code: MMResult;
begin
  Code := GetMasterVolumeControl(0, MasterVolume);
  if Code = MMSYSERR_NOERROR then
  begin
    with Details do
    begin
      cbStruct := SizeOf(Details);
      dwControlID := MasterVolume.dwControlID;
      cChannels := 1;  {set all channels}
      cMultipleItems := 0;
      cbDetails := SizeOf(UnsignedDetails);
      paDetails := @UnsignedDetails;
    end;
    mixerGetControlDetails(0, @Details,
                   MIXER_SETCONTROLDETAILSF_VALUE);
    Result:=UnsignedDetails.dwValue;
  end
  else
    result:=0;

END;

procedure TmMasterVol.SetMasterVolume(const Value: Word);
var
  MasterVolume: TMixerControl;
  Details: TMixerControlDetails;
  UnsignedDetails: TMixerControlDetailsUnsigned;
  Code: MMResult;
begin
  Code := GetMasterVolumeControl(Mixer, MasterVolume);
  if Code = MMSYSERR_NOERROR then
  begin
    with Details do
    begin
      cbStruct := SizeOf(Details);
      dwControlID := MasterVolume.dwControlID;
      cChannels := 1;  {set all channels}
      cMultipleItems := 0;
      cbDetails := SizeOf(UnsignedDetails);
      paDetails := @UnsignedDetails;
    end;
    mixerGetControlDetails(Mixer, @Details,
                   MIXER_SETCONTROLDETAILSF_VALUE);
    UnsignedDetails.dwValue := {UnsignedDetails.dwValue+}Value;
    mixerSetControlDetails(Mixer, @Details,
                   MIXER_SETCONTROLDETAILSF_VALUE);
  end;
END;

function TmMasterVol.GetMasterVolumeControl( Mixer: hMixerObj;
                           var Control: TMixerControl): MMResult;

{Returns True on success}
var
  Line: TMixerLine;
  Controls: TMixerLineControls;
begin
  ZeroMemory(@Line, SizeOf(Line));
  Line.cbStruct := SizeOf(Line);
  Line.dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS;
  Result := mixerGetLineInfo(Mixer, @Line, MIXER_GETLINEINFOF_COMPONENTTYPE);
  if Result = MMSYSERR_NOERROR then
  begin
    ZeroMemory(@Controls, SizeOf(Controls));
    Controls.cbStruct := SizeOf(Controls);
    Controls.dwLineID := Line.dwLineID;
    Controls.cControls := 1;
    Controls.dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME;
    Controls.cbmxctrl := SizeOf(Control);
    Controls.pamxctrl := @Control;
    Result := mixerGetLineControls(Mixer, @Controls,
                     MIXER_GETLINECONTROLSF_ONEBYTYPE);
  end;
end;



procedure TmMasterVol.SetMixer(const Value: HmixerObj);
begin
  FMixer := Value;
end;

end.
